<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DB;
use App\Http\Controllers\SharedController;
use Goutte\Client;
use Symfony\Component\HttpClient\HttpClient;
use Symfony\Component\DomCrawler\Crawler;

class AgendaController extends Controller
{

    protected $SharedController;

    public function __construct(SharedController $SharedController)
    {
        $this->SharedController = $SharedController;
    }

    public function getCategory($cat){
        return (array)DB::table('t_agenda_categories')->select('id', 'name')->where('libelle', $cat)->first();
    }
    public function formatData(){
        //	id_area	title	sub_title	description	price	style	image	sart_date	end_date	schedule	status	created_date	
        $query = "SELECT s.id as id_area, e.titre as title, e.soustitre as sub_title, e.texte as description, e.style as style, 
            e.image as image, a.laps as sart_end_date, a.date as created_date, a.horaire as schedule, a.prix as price, 
            CASE WHEN a.valid = 'v' THEN 1 ELSE 0 END as status,
         GROUP_CONCAT(DISTINCT e.genre) as categories FROM agenda as a LEFT JOIN events as e ON a.titre = e.titre LEFT JOIN t_areas as s ON s.acronym = a.salle GROUP BY e.titre, e.texte ORDER BY a.date ASC";

        $_results = DB::select( DB::raw($query) );

        foreach($_results as $r => $res){
            $sart_end_date = explode(">", $res->sart_end_date);
            unset($res->sart_end_date);
            $categories = explode(',', $res->categories);
            unset($res->categories);
            $date = $res->created_date;
            $res = (array)$res;
            
            $res['start_date'] = $this->formatDate((isset($sart_end_date[0]) && !empty(trim($sart_end_date[0]))) ? $sart_end_date[0] : $date);
            $res['end_date'] = $this->formatDate((isset($sart_end_date[1]) && !empty(trim($sart_end_date[1]))) ? $sart_end_date[1] : $date);            

            $id = DB::table('t_agendas')->insertGetId($res);

            foreach($categories as $c => $cat){
                $cat= trim($cat);
                echo $cat."-";
                if(strlen($cat) == 0)
                    continue;

                $q= "SELECT id FROM t_agenda_categories WHERE name like '%".$cat."%'";
                $id_cat = DB::select( DB::raw($q));
                if(count($id_cat) > 0){
                    $id_cat = $id_cat[0]->id;
                    echo $id_cat."-".$id."<br>";
                    $agenda_cat = array('id_agenda' => $id, 'id_agenda_category' => $id_cat);
                    DB::table('t_agenda_cat')->insert($agenda_cat);
                }
                
            }
        }
    }

    private function formatDate($date){
        $date = str_replace('/', '-', $date);
        return date('Y-m-d', strtotime($date));
    }

    public function getBydate($date, $slug = ''){
        $date = $this->formatDate($date);
        
        $subQuery = "";
        if ($slug) $subQuery = " AND c.libelle = '" . $slug . "'";
        $query = "SELECT CONCAT('[',GROUP_CONCAT('{ \"bg_color\" : \"',COALESCE(c.bg_color,''),'\",\"icon\" : \"',COALESCE(c.icon,''),'\", \"color\" : \"',c.color,'\", \"name\" : \"',c.name, '\"}'),']') as categories, CONCAT('{ \"address\" : \"',COALESCE(s.address,''),'\", \"description\" : \"',COALESCE(s.description,''),'\", \"web\" : \"',COALESCE(s.web_site,''),'\", \"phone\" : \"', COALESCE(s.phone,''), '\", \"name\" : \"', COALESCE(s.name,''), '\",\"acro\" : \"',COALESCE(s.acronym,''), '\"}') as area, a.title, a.id ,a.sub_title, a.description, a.price, a.style, a.image, a.start_date, a.end_date, a.schedule, a.lien_resa FROM t_agendas as a LEFT JOIN t_agenda_cat as ca ON ca.id_agenda = a.id LEFT JOIN t_agenda_categories as c ON c.id = ca.id_agenda_category LEFT JOIN t_areas as s ON s.id = a.id_area WHERE ('".$date."' BETWEEN a.start_date AND a.end_date) AND a.status = 1 " . $subQuery . " GROUP BY a.id ORDER BY a.end_date ASC";
        $results = DB::select(DB::raw($query));

        $this->SharedController->setCounter(5, 0, 0);

        return array_map(function($element) {
                $element->categories = json_decode($element->categories, true);
                $element->area = preg_replace("/[\n\r]/", "", $element->area);
                $element->area = json_decode($element->area, true);
                return $element;
            },
            $results
        );
    }

    public function getByCategory($id_cat){
        $date = $this->formatDate(date("Y/m/d"));
        $query = "SELECT CONCAT('[',GROUP_CONCAT('{ \"bg_color\" : \"',COALESCE(c.bg_color,''),'\",\"icon\" : \"',COALESCE(c.icon,''),'\", \"color\" : \"',c.color,'\", \"name\" : \"',c.name, '\", \"libelle\" : \"',c.libelle, '\"}'),']') as categories, CONCAT('{ \"address\" : \"',COALESCE(s.address,''),'\", \"description\" : \"',COALESCE(s.description,''),'\", \"web\" : \"',COALESCE(s.web_site,''),'\", \"phone\" : \"', COALESCE(s.phone,''), '\", \"name\" : \"', COALESCE(s.name,''), '\",\"acro\" : \"',COALESCE(s.acronym,''), '\"}') as area, a.title, a.id ,a.sub_title, a.description, a.price, a.style, a.image, a.start_date, a.end_date, a.schedule, a.lien_resa FROM t_agendas as a LEFT JOIN t_agenda_cat as ca ON ca.id_agenda = a.id LEFT JOIN t_agenda_categories as c ON c.id = ca.id_agenda_category LEFT JOIN t_areas as s ON s.id = a.id_area WHERE '".$date."' BETWEEN a.start_date AND a.end_date AND c.id = '".$id_cat."' AND a.status = 1 GROUP BY a.id ORDER BY a.end_date ASC";
        $results = DB::select(DB::raw($query));

        $this->SharedController->setCounter(5, 0, $id_cat);

        return array_map(function($element) {
                $element->categories = json_decode($element->categories, true);
                $element->area = preg_replace("/[\n\r]/", "", $element->area);
                $element->area = json_decode($element->area, true);
                return $element;
            },
            $results
        );
    }

    public function getById($id){
        $id = explode(':',base64_decode($id));
        if(count($id)>1){
            $id = $id[0];
        }else    
            $id = 0;
        
        $this->SharedController->setCounter(5, 0, $id);

        $query = "SELECT CONCAT('[',GROUP_CONCAT('{ \"bg_color\" : \"',COALESCE(c.bg_color,''),'\",\"icon\" : \"',COALESCE(c.icon,''),'\", \"color\" : \"',c.color,'\", \"name\" : \"',c.name, '\", \"libelle\" : \"',c.libelle, '\"}'),']') as categories, CONCAT('{ \"address\" : \"',COALESCE(s.address,''),'\", \"description\" : \"',COALESCE(s.description,''),'\", \"web\" : \"',COALESCE(s.web_site,''),'\", \"phone\" : \"', COALESCE(s.phone,''), '\", \"name\" : \"', COALESCE(s.name,''), '\",\"acro\" : \"',COALESCE(s.acronym,''), '\"}') as area, a.title, a.id ,a.sub_title, a.description, a.price, a.style, a.image, a.start_date, a.end_date, a.schedule, a.lien_resa FROM t_agendas as a LEFT JOIN t_agenda_cat as ca ON ca.id_agenda = a.id LEFT JOIN t_agenda_categories as c ON c.id = ca.id_agenda_category LEFT JOIN t_areas as s ON s.id = a.id_area WHERE a.id = '".$id."' AND a.status = 1 GROUP BY a.id ORDER BY a.end_date ASC";
        $results = DB::select(DB::raw($query));
        return array_map(function($element) {
                $element->categories = json_decode($element->categories, true);
                $element->area = preg_replace("/[\n\r]/", "", $element->area);
                $element->area = json_decode($element->area, true);
                return $element;
            },
            $results
        );
    }

    public function search($val){
        $date = $this->formatDate(date("Y/m/d"));
        $query = "SELECT CONCAT('[',GROUP_CONCAT('{ \"bg_color\" : \"',COALESCE(c.bg_color,''),'\",\"icon\" : \"',COALESCE(c.icon,''),'\", \"color\" : \"',c.color,'\", \"name\" : \"',c.name, '\", \"libelle\" : \"',c.libelle, '\"}'),']') as categories, CONCAT('{ \"address\" : \"',COALESCE(s.address,''),'\", \"description\" : \"',COALESCE(s.description,''),'\", \"web\" : \"',COALESCE(s.web_site,''),'\", \"phone\" : \"', COALESCE(s.phone,''), '\", \"name\" : \"', COALESCE(s.name,''), '\",\"acro\" : \"',COALESCE(s.acronym,''), '\"}') as area, COALESCE(a.title,a.sub_title) as title , a.id ,a.sub_title, a.description, a.price, a.style, a.image, a.start_date, a.end_date, a.schedule, a.lien_resa FROM t_agendas as a LEFT JOIN t_agenda_cat as ca ON ca.id_agenda = a.id LEFT JOIN t_agenda_categories as c ON c.id = ca.id_agenda_category LEFT JOIN t_areas as s ON s.id = a.id_area WHERE (a.title LIKE '%".$val."%' OR a.description LIKE '%".$val."%' OR a.sub_title LIKE '%".$val."%') AND a.status = 1 GROUP BY a.id  ORDER BY a.end_date DESC LIMIT 50 ";
        $results = DB::select(DB::raw($query));
        return array_map(function($element) {
                $element->categories = json_decode($element->categories, true);
                $element->area = preg_replace("/[\n\r]/", "", $element->area);
                $element->area = json_decode($element->area, true);                   
                return $element;
            },
            $results
        );
    }
    
    public function categories(){
        $query = "SELECT id, name, color, libelle FROM t_agenda_categories WHERE status = 1 ORDER BY display_order, name ASC";
        $results = DB::select(DB::raw($query));
        return $results;
    }

    public function areas(){
        $query = "SELECT name, id FROM t_areas GROUP BY name ORDER BY name ASC";
        $results = DB::select(DB::raw($query));
        return $results;
    }

    public function add(Request $request){
        $agenda = json_decode($request->input('data'));

        $categories = $agenda->categories;

        unset($agenda->categories);
        /*unset($agenda->name);
        unset($agenda->fname);
        unset($agenda->email);*/
        $agenda= (array) $agenda;
        $id = DB::table('t_agendas')->insertGetId($agenda);

        foreach($categories as $c){
            $d = array(
                'id_agenda_category' => $c,
                'id_agenda' => $id
            );
            $id = DB::table('t_agenda_cat')->insertGetId($d);

        }
        return $agenda;
    }
    
    
    
    public function getElementsByClass(&$parentNode, $tagName, $className)
    {

        $nodes = array();



        $childNodeList = $parentNode->getElementsByTagName($tagName);

        for ($i = 0; $i < $childNodeList->length; $i++) {

            $temp = $childNodeList->item($i);

            if (stripos($temp->getAttribute('class'), $className) !== false) {

                $nodes[] = $temp;
            }
        }



        return $nodes;
    }



    public function gettheatre()
    {

        $theatredupaveURL = "https://theatredupave.festik.net";

        $theatredupaveHTML = $this->SharedController->curl_get_contents('https://theatredupave.festik.net/');



        $dom = new \DOMDocument();

        @$dom->loadHTML($theatredupaveHTML);



        $domNodeList = $this->getElementsByClass($dom, 'div', 'a');



        // Remove Img tags from H3 and place it before the H# tag

        /*foreach ($domNodeList as $domNode) {

            if ($domNode->parentNode->nodeName == "h3") {

                $parentNode = $domNode->parentNode;

                $parentParentNode = $parentNode->parentNode;



                $parentParentNode->insertBefore($domNode, $parentNode->nextSibling);

            }

        }*/



        return  $domNodeList;
    }



    public function updateAgenda()
    {

        $lienPage = 'https://www.theatregaronne.com/saison';

        $client = new Client();

        $crawler = $client->request('GET', $lienPage);

        $allDataDB = [

            "id_area" => 6,

            "title" => "",

            "description" => "",

            "status" => 1

        ];

        $allArticle = $crawler->filter('.event_list .theatre')->each(function ($elementArticle) use ($allDataDB) {

            $titre = $elementArticle->filter('h2')->getNode(0)->nodeValue;

            $allDataDB["title"] = $titre;

            var_dump($allDataDB);

            echo "<br><br>";

            //insertion dans la base quand toutes les données de l'article en cours sont complètes  

        });

        return "Finished";
    }

    public function getAllScrapping(){
        $query = "SELECT id, titre, lien, status FROM t_agenda_scrapping WHERE lien <> '' and lien is not null";
        $results = DB::select(DB::raw($query));
        return $results;
    }

    private function _checkArticleExist($slug){

        $retour = (array)DB::table('t_agendas')->select('id')->where([

            ["slug", "=", $slug]

        ])->first();

        if (count($retour) > 0) return true;

        else return false;

    }
	
	
    private function getIdTheater($titre, $theaterLink = "", $slug, $isLaunch)
    {
        
        if ($theaterLink == "") return 0;

        $client = new Client();
        $crawler = $client->request('GET', 'https://zenith-toulousemetropole.com/' . $theaterLink);

        $description = "";

        $d1 = $crawler->filter(".fiche-desc");
        if (is_object($d1)) {
            $d2 = $d1->getNode(0);
            if (is_object($d2)) {
                $description = $d2->nodeValue;
            }
        }

        $price = $crawler->filter(".fiche-info-globales .fiche-tarif .data")->getNode(0)->nodeValue;

        $style = $crawler->filter(".fiche-info-globales .fiche-categories .data")->getNode(0)->nodeValue;
		
		$slugs = explode('/',$theaterLink);

        $slug = $slugs[count($slugs) - 1];
		
		$months = array(
                  "Jan"=> 01,
                  "Fév"=> 02,
                  "Mar" => 03,
                  "Avr" => 04,
                  "Mai" => 05,
                  "Jui" => 06,
                  "Juil" => 07,
                  "Aou" => 8,
                  "Sep" => 9,
                  "Oct" => 10,
                  "Nov" => 11,
                  "Dec" => 12
                );

        $date_start = "";
        $date_end = "";

        $ds1 = $crawler->filter(".fiche-dates .dates .date");

        if (is_object($ds1)) {
            $ds2 = $ds1->getNode(0);
            if (is_object($ds2)) {
                $date_start = $ds2->nodeValue;
            }
            
            $df2 = $ds1->getNode(count($ds1) -1);
            
            if (is_object($df2)) {
                $date_end = $df2->nodeValue;
            }
        }
		
		$date_start = trim(preg_replace('!\s+!', ' ', $date_start));
		$date_end = trim(preg_replace('!\s+!', ' ', $date_end));
		
		$start_date = explode(' ', $date_start);
		$start_month = explode(' ', $start_date[2]);
		
		$end_date = explode(' ', $date_end);
		$end_month = explode(' ', $end_date[2]);
		
		$month = $months[$start_month[0]];
		$monthEnd = $months[$end_month[0]];
		
		$string_date =  $start_date[3] . "-" . (((int)$month < 10) ? "0" . (int)$month : (int)$month) . "-" .  $start_date[1];
		$string_date_end =  $end_date[3] . "-" . (((int)$monthEnd < 10) ? "0" . (int)$monthEnd : (int)$monthEnd) . "-" .  $end_date[1];
		
		
		$string_date_to_date = date('Y-m-d', strtotime($string_date));
		$string_date_to_date_end = date('Y-m-d', strtotime($string_date_end));
		
		
        $schedule = $crawler->filter(".fiche-dates .seancespectacle .data-horaire")->getNode(0)->nodeValue;

        $image = $crawler->filter(".image-spectacle img")->attr("src");

        $dataTheater = [

            "title" => $titre,

            "sub_title" => "",

            "description" => $description,

            "price" => $price,

            "style" => $style,

            "image" => "https://zenith-toulousemetropole.com/" . $image,

            "start_date" => $string_date_to_date,

            "end_date" => $string_date_to_date_end,

            "schedule" => $schedule,

            "lien_resa" => "",
			
			"slug" => $slug,

            "status" => 1
        ];
		
		$id_category = 0;

		if(str_contains($style, 'Ciné-concert') || str_contains($style, 'Pop / Rock / Blues') || str_contains($style, 'Rap / Hip Hop')){
			$id_category = 3;
		}
		elseif(str_contains($style, 'Cirque')){
			$id_category = 22;
		}
		elseif(str_contains($style, 'Classique') || str_contains($style, 'Danse')){
			$id_category = 12;
		}
		elseif(str_contains($style, 'Comédie musicale') || str_contains($style, 'Electro') || str_contains($style, 'Gospel') || str_contains($style, 'Jazz') || str_contains($style, 'Métal') || str_contains($style, 'Musique du monde') || str_contains($style, 'Variété française') || str_contains($style, 'Variété française')){
			$id_category = 20;
		}
		elseif(str_contains($style, 'Humour') || str_contains($style, 'Magie Hypnose') || str_contains($style, 'Spectacle enfants')){
			$id_category = 7;
		}
		elseif(str_contains($style, 'Patinage') || str_contains($style, 'Sport')){
			$id_category = 6;
		}
		elseif(str_contains($style, 'Théâtre')){
			$id_category = 4;
		}

		if ($isLaunch === 1 || !$isLaunch){
            DB::table('t_agendas')->updateOrInsert(['slug' => $slug],$dataTheater);
                        
            $id = DB::getPdo()->lastInsertId();
            if ($id && $id != 0){
                DB::table('t_agenda_cat')->updateOrInsert(['id_agenda' => $id],['id_agenda_category' => $id_category]);    
            }
        }

        return $dataTheater;
        
    }

    public function updateAgendaforZenith($isLaunch = 1)
    {

        $lienPage = 'https://zenith-toulousemetropole.com/';

        $client = new Client();

        $crawler = $client->request('GET', $lienPage);

        $allDataDB = [

            "id_area" => 6,

            "title" => "",

            "subtitle" => "",

            "description" => "",

            "price" => "",

            "style" => "",

            "image" => "",

            "start_date" => "",

            "end_date" => "",

            "schedule" => "",

            "lien_resa" => "",

            "status" => 1

        ];



        $allArticle = $crawler->filter('.event-details')->each(function ($elementArticle) use ($allDataDB, $isLaunch) {

            $titre = $elementArticle->filter('h2')->getNode(0)->nodeValue;

            $allDataDB["title"] = $titre;

            $nextLink = $elementArticle->filter('.event-infos .readmore a')->attr('href');

			$slugs = explode('/',$nextLink);

			$slug = $slugs[count($slugs) - 1];
			
            //insertion dans la base quand toutes les données de l'article en cours sont complètes

            $ret = $this->getIdTheater($titre, $nextLink, $slug, $isLaunch);

            return ["title" =>$ret["title"], "start_date" =>$ret["start_date"], "end_date" =>$ret["end_date"]];
        });

        return $allArticle;
    }
	
	private function getIdTheaterCapitole($titre, $theaterLink = "")
    {
        //$ligfilm = DB::table('t_cine_film')->where('slug', $this->SharedController->formatToSlug($titre))->first();

        if ($theaterLink == "") return 0;

        $client = new Client();
        $crawler = $client->request('GET', 'https://www.theatreducapitole.fr/' . $theaterLink);
        //$array = $crawler->filter('.entity-card')->each(function ($element) {
        //$titre = $crawler->filter(".fiche-info")->getNode(0)->nodeValue;

        /*$bodyInfo = $crawler->filter(".entity-card .meta-body-info")->getNode(0)->nodeValue;
				
                $bodyInfos = explode("/", $bodyInfo);
                $genres = end($bodyInfos);*/

		$subtitle = "";
		
		if($crawler->filter('#toggable-upper-title .event-composer')->count() > 0){
			
			$subtitle  = $crawler->filter('#toggable-upper-title .event-composer')->getNode(0)->nodeValue;
			
		}

		
        $description = "";

        $d1 = $crawler->filter(".event-description");
        if (is_object($d1)) {
            $d2 = $d1->getNode(0);
            if (is_object($d2)) {
                $description = $d2->nodeValue;
            }
        }

        $price = $crawler->filter(".complementary-informations__data")->getNode(0)->nodeValue;
		
		$array_price = explode('Tarif', $price);
		
		$real_price = "";
		
		if(count($array_price) > 1){
			$real_price = $array_price[1];
		}

        $style = '';
		
		$slugs = explode('/',$theaterLink);

        $slug = $slugs[count($slugs) - 1];
		
		$months = array(
  "janvier"=> 01,
  "février"=> 02,
  "mars" => 03,
  "avril" => 04,
  "mai" => 05,
  "juin" => 06,
  "juillet" => 07,
  "aout" => 8,
  "septembre" => 9,
  "octobre" => 10,
  "novembre" => 11,
  "décembre" => 12
);

        $date_start = "";

        $ds1 = $crawler->filter(".location-dates-container .dates-display")->getNode(0)->nodeValue;
		
		$start_date = explode(' ', $ds1);
		
		$date_end = "";
		
		$month = $months[$start_date[3]];
		
		$string_date = $start_date[4].'/'.$month.'/'.$start_date[2];
		
		$string_date_to_date = date('Y-m-d', strtotime($string_date));
		
		if(count($start_date) > 6) {
			
			$month_end = $months[$start_date[7]];
			$string_date_end = $start_date[8].'/'.$month_end.'/'.$start_date[6];
			$date_end = date('Y-m-d', strtotime($string_date_end));
		}


        $schedule = $array_price[0];

        $image = $crawler->filter(".event-header-image")->attr("style");
		
		$image = $crawler->filter(".event-header-image")->attr("style");
		
		$image = str_replace("background-image:url('", "", $image);
		
		$image = str_replace("')", "", $image);
		
		
		$lien_resa = "";
		
		if ($crawler->filter('.complementary-informations a')->count() > 0){
			
			$lien_resa = $crawler->filter('.complementary-informations a')->attr('href');
			
		}

        $dataTheater = [

            "title" => $titre,

            "sub_title" => $subtitle,

            "description" => $description,

            "price" => $real_price,

            "style" => $style,

            "image" => $image,

            "start_date" => $string_date_to_date,

            "end_date" => $date_end,

            "schedule" => $schedule,

            "lien_resa" => $lien_resa,
			
			"slug" => $slug,

            "status" => 1
        ];
		
		$id_category = 4;

		
        DB::table('t_agendas')->insert($dataTheater);
                $id = DB::getPdo()->lastInsertId();

		$dataAgendaCat = [
		
			"id_agenda" => $id,

            "id_agenda_category" => $id_category,
			
		];
		

        DB::table('t_agenda_cat')->insert($dataAgendaCat);
		
		var_dump($dataTheater);

    }
	
	public function updateAgendaforCapitole()
    {

        $lienPage = 'https://www.theatreducapitole.fr/programmation';

        $client = new Client();

        $crawler = $client->request('GET', $lienPage);



        $allDataDB = [

            "title" => "",

        ];



        $allArticle = $crawler->filter('.list-event article')->each(function ($elementArticle) use ($allDataDB) {

            $titre = $elementArticle->filter('.infos .title')->getNode(0)->nodeValue;

            $allDataDB["title"] = $titre;

            $nextLink = $elementArticle->filter('.event-item .content a')->attr('href');

            echo "<br><br>";

            //insertion dans la base quand toutes les données de l'article en cours sont complètes


            $this->getIdTheaterCapitole($titre, $nextLink);
        });



        return "Finished";
    }
    
    
    public function updateAgendaRugby(){
        $lienPage = 'https://www.stadetoulousain.fr/equipe-pro/calendrier';
        
        $client = new Client();
        $crawler = $client->request('GET', $lienPage); 
        
        
        //  id_area 3757 Toulousain State
        //  name => vide pour saisie auto
        //  fname => vide pour saisie auto
        //  email => vide pour saisie auto
        //  title
        //  sub_title
        //  description
        //  price: varchar
        //  style =>  => vide pour saisie auto
        //  image => varchar url
        //  start_date => date
        //  end_date => date
        //  schedule => horaire
        //  lien_resa => varchar lien 
        //  status => 1 car toujours actif
        
        //t_agenda_categories: 4 theatre, ...
        
        $allDataDB = [
                "id_area" => 3758,
                "title" => "",
                "description" => "",
                "status" => 1,
                "slug" => ""
            ];
            
        $allMois = $crawler->filter('.bloc_mois_calendier')->each(function ($mois) use ($allDataDB) {
            
            $moisTxt = $mois->filter(".mois-fleche-calendrier h2")->getNode(0)->nodeValue;
            var_dump($moisTxt);
            
            
            $allMoisArticles = $mois->filter('article')->each(function ($article) use ($allDataDB, $moisTxt) {
                $listeMois = ['janvier', 'fevrier', 'mars', 'avril', 'mai', 'juin', 'juillet', 'aout', 'septembre', 'octobre', 'novembre', 'decembre'];
                $listeMoisAccent = ['janvier', 'février', 'mars', 'avril', 'mai', 'juin', 'juillet', 'août', 'septembre', 'octobre', 'novembre', 'décembre'];
                
                $jourDebut = 0;
                $jourFin = 0;
                
                $jour = $article->filter(".day_number_date_calendrier")->getNode(0)->nodeValue; 
                $jour = trim($jour);
                if (str_contains($jour, ' - ')) {
                    $jr = explode(' - ', $jour);
                    $jourDebut = $jr[0];
                    $jourFin = $jr[1]; 
                } else {
                    $jourDebut = $jour;
                    $jourFin = $jour;
                }
                
                $jourDebut = trim($jourDebut);
                $jourFin = trim($jourFin);
                
                $jourDebut = ((int)($jourDebut) < 10) ? "0" . $jourDebut : $jourDebut;
                $jourFin = ((int)($jourFin) < 9) ? "0" . $jourFin : $jourFin;
                
                $year = date('Y');
                
                $mois = array_search(strtolower($moisTxt), $listeMois);
                if (!$mois) $mois = array_search(strtolower($moisTxt), $listeMoisAccent);
                
                $mois = (int)($mois) + 1;
                
                $mois = ($mois < 10) ? "0" . $mois : $mois;
                
                $start_date = $year . "-" . $mois . "-" . $jourDebut;
                $end_date = $year . "-" . $mois . "-" . $jourFin;
                
                $title = $article->filter(".libelle_match_calendrier h3")->getNode(0)->nodeValue; 
                $title = strtoupper($title);
                
                /*var_dump($title);
                echo "<br>";*/
                
                $description = $article->filter(".libelle_match_calendrier p")->getNode(0)->nodeValue; 
                
                $heures = explode(" - ", $description);
                $schedule = end($heures);
                
                //recharger les valeurs
                $allDataDB["title"] = $title;
                $allDataDB["description"] = $description;
                $allDataDB["start_date"] = $start_date;
                $allDataDB["end_date"] = $end_date;
                $allDataDB["schedule"] = $schedule;
                $allDataDB["slug"] = str_replace(" ", "_", $title);
                
                $allimages = $article->filter('.hidden-xs img.logo_equipe_calendrier')->each(function ($img) use ($article, $allDataDB) {
                    $imgLien = $img->attr('src');
                    
                    //var_dump(strpos($imgLien, 'ST.png')); 
                    if (!strpos($imgLien, 'ST.png')) {
                        echo $imgLien . " | ";
                        $allDataDB['image'] = $imgLien;
                        
                        $hasResa = false;
                        
                        
                        var_dump(count($article->filter('.plateform_calendrier a.red')));
                        
                        if (count($article->filter('.plateform_calendrier a.red')) > 0){
                            $allDataDB['lien_resa'] = "https://billetterie.stadetoulousain.fr/";
                        }
                        var_dump($allDataDB); 
                        
                        DB::table('t_agendas')->updateOrInsert(['slug' => $allDataDB['slug']],$allDataDB);
                        
                        $id = DB::getPdo()->lastInsertId();
                        echo $id . " - ";
                        if ($id && $id != 0){
                            DB::table('t_agenda_cat')->updateOrInsert(['id_agenda' => $id],['id_agenda_category' => 6]);    
                        }
                    }
                });
                
                //var_dump($allimages); 
                echo "<br><br>";
                
                
                
                
            });
            
        });
        
        return "Finished";
    }
}