<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
//use Illuminate\Support\Facades\Request;
use DB;
use App\Http\Controllers\SharedController;
use Goutte\Client;
use Symfony\Component\HttpClient\HttpClient;
use Symfony\Component\DomCrawler\Crawler;

class CinemaController extends Controller
{
    protected $SharedController;
    
    public function __construct(SharedController $SharedController)
    {
        $this->SharedController = $SharedController;
    }
    
    /**
     * Handle the incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function __invoke(Request $request)
    {
        //
    }

    public function wLogs($data)
    {
        $logPath = "logs.txt";
        $mode = (!file_exists($logPath)) ? 'w':'a';
        $logfile = fopen($logPath, $mode);
        fwrite($logfile, "\r\n". $data);
        fclose($logfile);
    }

    public function getCine($idCategCine, $idCine)
    {
        $where = "";

        if ($idCategCine != 0 && $where == ""){
            $where .= " where id_cine_categ = " . $idCategCine;
        } else if ($idCategCine != 0 && $where != ""){
            $where .= " and id_cine_categ = " . $idCategCine;
        }

        if ($idCine != 0 && $where == ""){
            $where .= " where id = " . $idCine;
        } else if ($idCine != 0 && $where != ""){
            $where .= " and id = " . $idCine;
        }

        if ($where == ""){
            $where .= " where status = 1";
        } else {
            $where .= " and status = 1";
        }


        $sql = "select * from t_cine" . $where . " order by nom asc";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }


    public function getCineBySlug($idCategCine, $slug)
    {
        $where = "";

        if ($idCategCine != 0 && $where == ""){
            $where .= " where id_cine_categ = " . $idCategCine;
        } else if ($idCategCine != 0 && $where != ""){
            $where .= " and id_cine_categ = " . $idCategCine;
        }

        if ($slug && $where == ""){
            $where .= " where slug = '" . $slug . "'";
        } else if ($slug != 0 && $where != ""){
            $where .= " and slug = '" . $slug . "'";
        }


        $sql = "select * from t_cine" . $where . " order by nom asc";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }


    public function getFilmsByCine($idCine, $datedeb, $datefin)
    {
        $sql = "SELECT cf.*, cp.start_date as date, cp.monday, cp.tuesday, cp.wednesday, cp.thursday, cp.friday,cp.saturday, cp.sunday, cp.avant_premiere, cl.langue, GROUP_CONCAT(ctp.type) as type
                FROM t_cine_film cf
                    LEFT JOIN t_cine_projection cp on cf.id = cp.id_cine_film
                    LEFT JOIN t_cine_lang cl on cp.id_cine_lang = cl.id
                    LEFT JOIN t_cine_proj_types cpt on cp.id = cpt.id_proj
                    LEFT JOIN t_cine_type_projection ctp on cpt.id_type = ctp.id
                WHERE
                    cp.id_cine = " . $idCine . " and cp.start_date >= '" . $datedeb . "' and cp.start_date <= '" . $datefin . "'
                GROUP BY cp.id, cp.start_date
                ORDER BY cp.start_date ASC";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getFilmsByCineSlug($salleSlug, $datedeb, $datefin, $id)
    { 
            $sql = "SELECT cf.slug, cf.titre, cf.duree, cf.realisateur, cf.nationalites, cf.genres, cf.distributeur, c.slug as salleSlug, cp.start_date as date, 
                (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = cp.id and jour = 1) as monday,
                (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = cp.id and jour = 2) as tuesday,
                (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = cp.id and jour = 3) as wednesday,
                (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = cp.id and jour = 4) as thursday,
                (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = cp.id and jour = 5) as friday,
                (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = cp.id and jour = 6) as saturday,
                (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = cp.id and jour = 0) as sunday,
                cp.avant_premiere, cl.langue,
                (select GROUP_CONCAT(ctp.type) from t_cine_type_projection ctp inner join t_cine_proj_types cpt on cpt.id_type = ctp.id where cpt.id_proj = cp.id) as type,
            (select count(*) from t_cine_comment cc where cc.id_cine_film = cf.id and cc.status = 1) as nbComment
            FROM t_cine_projection cp
                inner JOIN t_cine_film cf on cf.id = cp.id_cine_film
                inner JOIN t_cine_lang cl on cp.id_cine_lang = cl.id
                inner JOIN t_cine c on cp.id_cine = c.id
            WHERE
                c.slug = '" . $salleSlug . "' and 
                ((
                    ('" . $datedeb . "' >= cp.start_date and '" . $datedeb . "' <=  cp.end_date)
                    or 
                    ('" . $datefin . "' >= cp.start_date and '" . $datefin . "' <= cp.end_date)
                )
                    or (
                    (cp.start_date >= '" . $datedeb . "' and cp.start_date <= '" . $datefin . "') 
                        and 
                        (cp.end_date >= '" . $datedeb . "' and cp.end_date <= '" . $datefin . "')
                    )
                ) and cp.id = " . $id . "
            ORDER BY cp.start_date ASC";
            
        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getFilmsIdByCineSlug($salleSlug, $datedeb, $datefin)
    {
            $sql = "SELECT cp.id as id
            FROM t_cine_projection cp
                inner JOIN t_cine_film cf on cf.id = cp.id_cine_film
                inner JOIN t_cine_lang cl on cp.id_cine_lang = cl.id
                inner JOIN t_cine c on cp.id_cine = c.id
            WHERE
                c.slug = '" . $salleSlug . "' and 
                ((
                    ('" . $datedeb . "' >= cp.start_date and '" . $datedeb . "' <=  cp.end_date)
                    or 
                    ('" . $datefin . "' >= cp.start_date and '" . $datefin . "' <= cp.end_date)
                )
                    or (
                    (cp.start_date >= '" . $datedeb . "' and cp.start_date <= '" . $datefin . "') 
                        and 
                        (cp.end_date >= '" . $datedeb . "' and cp.end_date <= '" . $datefin . "')
                    )
                )
            ORDER BY cp.start_date ASC";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }
    
    public function getFilmsByCineSlugOpt($salleSlug, $datedeb, $datefin)
    {
        /*$sql = "SELECT cp.id as cpId,cf.slug, cf.titre, cf.duree, cf.realisateur, cf.nationalites, cf.genres, cf.distributeur, c.slug as salleSlug, cp.start_date as date, 
                    cp.avant_premiere, cl.langue,
                    (select GROUP_CONCAT(ctp.type) from t_cine_type_projection ctp inner join t_cine_proj_types cpt on cpt.id_type = ctp.id where cpt.id_proj = cp.id) as type,
                (select count(*) from t_cine_comment cc where cc.id_cine_film = cf.id and cc.status = 1) as nbComment
                FROM t_cine_projection cp
                    inner JOIN t_cine_film cf on cf.id = cp.id_cine_film
                    inner JOIN t_cine_lang cl on cp.id_cine_lang = cl.id
                    inner JOIN t_cine c on cp.id_cine = c.id
                WHERE
                    c.slug = '" . $salleSlug . "' and 
                    ((
                        ('" . $datedeb . "' >= cp.start_date and '" . $datedeb . "' <=  cp.end_date)
                        or 
                        ('" . $datefin . "' >= cp.start_date and '" . $datefin . "' <= cp.end_date)
                    )
                        or (
                        (cp.start_date >= '" . $datedeb . "' and cp.start_date <= '" . $datefin . "') 
                            and 
                            (cp.end_date >= '" . $datedeb . "' and cp.end_date <= '" . $datefin . "')
                        )
                    )
                ORDER BY cp.start_date ASC";

        $results = DB::select( DB::raw($sql) );
        $resultFinal = array();
        
        foreach ($results as $result){
            $sqlTemp = "SELECT (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = " . $result->cpId . " and jour = 1) as monday,
                        (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = " . $result->cpId . " and jour = 2) as tuesday,
                        (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = " . $result->cpId . " and jour = 3) as wednesday,
                        (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = " . $result->cpId . " and jour = 4) as thursday,
                        (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = " . $result->cpId . " and jour = 5) as friday,
                        (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = " . $result->cpId . " and jour = 6) as saturday,
                        (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = " . $result->cpId . " and jour = 0) as sunday";
            $resultsTmp = DB::select( DB::raw($sqlTemp) );
            
            $result = (object) array_merge((array) $result, (array) $resultsTmp[0]);
            array_push($resultFinal, $result);
        }*/

        $sql = "SELECT cf.slug, cf.titre, cf.duree, cf.realisateur, cf.nationalites, cf.genres, cf.distributeur, c.slug as salleSlug, cp.start_date as date, 
                (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = cp.id and jour = 1) as monday,
                (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = cp.id and jour = 2) as tuesday,
                (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = cp.id and jour = 3) as wednesday,
                (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = cp.id and jour = 4) as thursday,
                (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = cp.id and jour = 5) as friday,
                (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = cp.id and jour = 6) as saturday,
                (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = cp.id and jour = 0) as sunday,
                cp.avant_premiere, cl.langue,
                (select GROUP_CONCAT(ctp.type) from t_cine_type_projection ctp inner join t_cine_proj_types cpt on cpt.id_type = ctp.id where cpt.id_proj = cp.id) as type,
            (select count(*) from t_cine_comment cc where cc.id_cine_film = cf.id and cc.status = 1) as nbComment
            FROM t_cine_projection cp
                inner JOIN t_cine_film cf on cf.id = cp.id_cine_film
                inner JOIN t_cine_lang cl on cp.id_cine_lang = cl.id
                inner JOIN t_cine c on cp.id_cine = c.id
            WHERE
                c.slug = '" . $salleSlug . "' and 
                ((
                    ('" . $datedeb . "' >= cp.start_date and '" . $datedeb . "' <=  cp.end_date)
                    or 
                    ('" . $datefin . "' >= cp.start_date and '" . $datefin . "' <= cp.end_date)
                )
                    or (
                    (cp.start_date >= '" . $datedeb . "' and cp.start_date <= '" . $datefin . "') 
                        and 
                        (cp.end_date >= '" . $datedeb . "' and cp.end_date <= '" . $datefin . "')
                    )
                )
            ORDER BY cp.start_date ASC";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getFilmDetail($idFilm)
    {
        $sql = "SELECT cf.*, cp.start_date as date, cp.monday, cp.tuesday, cp.wednesday, cp.thursday, cp.friday,cp.saturday, cp.sunday, cp.avant_premiere, cl.langue, GROUP_CONCAT(ctp.type) as type
                FROM t_cine_film cf
                    LEFT JOIN t_cine_projection cp on cf.id = cp.id_cine_film
                    LEFT JOIN t_cine_lang cl on cp.id_cine_lang = cl.id
                    LEFT JOIN t_cine_proj_types cpt on cp.id = cpt.id_proj
                    LEFT JOIN t_cine_type_projection ctp on cpt.id_type = ctp.id
                WHERE
                    cf.id = " . $idFilm . "
                GROUP BY cp.id,cp.start_date
                ORDER BY cp.start_date ASC";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getFilmDetailBySlug($filmSlug)
    {
        $sql = "SELECT cf.*, cp.start_date as date, cp.monday, cp.tuesday, cp.wednesday, cp.thursday, cp.friday,cp.saturday, cp.sunday, cp.avant_premiere, cl.langue, GROUP_CONCAT(ctp.type) as type, cf.slug
                FROM (SELECT * FROM t_cine_film where slug = '" . $filmSlug . "') cf
                    LEFT JOIN t_cine_projection cp on cf.id = cp.id_cine_film
                    LEFT JOIN t_cine_lang cl on cp.id_cine_lang = cl.id
                    LEFT JOIN t_cine_proj_types cpt on cp.id = cpt.id_proj
                    LEFT JOIN t_cine_type_projection ctp on cpt.id_type = ctp.id
                WHERE
                    cf.slug = '" . $filmSlug . "'
                GROUP BY cp.id, cp.start_date
                ORDER BY cp.start_date ASC";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function searchFilm($filmToSearch)
    {
        $sql = "SELECT count(c.id_cine_film) as nbComment, f.id, f.titre, f.slug
        FROM `t_cine_film` f
        LEFT JOIN t_cine_comment c on f.id = c.id_cine_film
        WHERE lower(f.titre) like '%" . $filmToSearch . "%'
        GROUP BY c.id_cine_film
        ORDER BY f.titre";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getFilmCommentsBySlug($filmSlug)
    {
        $sql = "SELECT 
					CONCAT('[', GROUP_CONCAT(concat('{\"comment\":\"', REPLACE(REPLACE(REPLACE(c.commentaire,'\n',' '),'\r',' '), '\"', ''), '\", \"date\":\"', c.date, '\", \"pseudo\":\"', c.pseudo, '\"}') SEPARATOR ','), ']') as comments, f.id, f.titre, f.slug, f.realisateur, f.synopsis 
				FROM t_cine_film f 
				LEFT JOIN (select * from t_cine_comment where status = 1) c on f.id = c.id_cine_film 
				WHERE f.slug = '" . $filmSlug . "'
				GROUP BY c.id_cine_film 
				ORDER BY f.titre";

        $results = DB::select( DB::raw($sql) );

        if (count($results) > 0){
            $comments = $results[0]->comments;
            $results[0]->comments = str_replace("\\","", $comments);
        }

        return $results;
    }

    public function addComment(Request $request)
    {
        $data = $request->input('data');

        $data = (array) json_decode($data);

        DB::table('t_cine_comment')->insert($data);
        $id = DB::getPdo()->lastInsertId();

        return $id;
    }

    public function getFilmPlusCommenter()
    {
        $sql = "SELECT count(cc.id_cine_film) as nbComment, cf.id,cf.titre,cf.slug FROM t_cine_film cf
                LEFT JOIN t_cine_comment cc on cf.id = cc.id_cine_film
                where cc.status = 1
                GROUP BY cc.id_cine_film
                HAVING count(cc.id_cine_film) > 0
                ORDER BY nbComment DESC
                LIMIT 5";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getFilmsPanorama($datedeb, $datefin)
    {
        /*$sql = "SELECT cf.*, c.slug as salleSlug
                FROM t_cine_film cf
                    LEFT JOIN t_cine_projection cp on cf.id = cp.id_cine_film
                    LEFT JOIN t_cine_lang cl on cp.id_cine_lang = cl.id
                    LEFT JOIN t_cine_proj_types cpt on cp.id = cpt.id_proj
                    LEFT JOIN t_cine_type_projection ctp on cpt.id_type = ctp.id
                    LEFT JOIN t_cine c on cp.id_cine = c.id
                WHERE
                    ((
                        ('" . $datedeb . "' >= cp.start_date and '" . $datedeb . "' <=  cp.end_date)
                        or 
                        ('" . $datefin . "' >= cp.start_date and '" . $datefin . "' <= cp.end_date)
                    )
                        or (
                        (cp.start_date >= '" . $datedeb . "' and cp.start_date <= '" . $datefin . "') 
                            and 
                            (cp.end_date >= '" . $datedeb . "' and cp.end_date <= '" . $datefin . "')
                        )
                    )
                GROUP BY cf.id
                ORDER BY cf.titre ASC";*/
                
        $sql = "SELECT cf.titre, cf.slug
                FROM t_cine_film cf
                    LEFT JOIN t_cine_projection cp on cf.id = cp.id_cine_film
                WHERE
                    ((
                        ('" . $datedeb . "' >= cp.start_date and '" . $datedeb . "' <=  cp.end_date)
                        or 
                        ('" . $datefin . "' >= cp.start_date and '" . $datefin . "' <= cp.end_date)
                    )
                        or (
                        (cp.start_date >= '" . $datedeb . "' and cp.start_date <= '" . $datefin . "') 
                            and 
                            (cp.end_date >= '" . $datedeb . "' and cp.end_date <= '" . $datefin . "')
                        )
                    )
                GROUP BY cf.id
                ORDER BY cf.titre ASC";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getFilmsPanoramaSalles($filmSlug, $datedeb, $datefin)
    {
        $sql = "SELECT cf.slug, cf.titre, GROUP_CONCAT(ctp.type) as type, c.slug as salleSlug, c.nom as salleNom, c.adresse as salleAdresse, c.cp as salleCP, c.ville as salleVille, 
                    (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = cp.id and jour = 1) as monday,
                    (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = cp.id and jour = 2) as tuesday,
                    (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = cp.id and jour = 3) as wednesday,
                    (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = cp.id and jour = 4) as thursday,
                    (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = cp.id and jour = 5) as friday,
                    (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = cp.id and jour = 6) as saturday,
                    (SELECT concat('[', GROUP_CONCAT(concat('{\"heure\":\"', heure, '\", \"lien_resa\":\"', lien_resa, '\"}')), ']') FROM `t_cine_proj_heures` WHERE `id_cine_proj` = cp.id and jour = 0) as sunday,
         cp.avant_premiere
            FROM t_cine_film cf
                LEFT JOIN t_cine_projection cp on cf.id = cp.id_cine_film
                LEFT JOIN t_cine_lang cl on cp.id_cine_lang = cl.id
                LEFT JOIN t_cine_proj_types cpt on cp.id = cpt.id_proj
                LEFT JOIN t_cine_type_projection ctp on cpt.id_type = ctp.id
                LEFT JOIN t_cine c on cp.id_cine = c.id
            WHERE
                cf.slug = '" . $filmSlug . "' and
                ((
                    ('" . $datedeb . "' >= cp.start_date and '" . $datedeb . "' <=  cp.end_date)
                    or 
                    ('" . $datefin . "' >= cp.start_date and '" . $datefin . "' <= cp.end_date)
                )
                    or (
                    (cp.start_date >= '" . $datedeb . "' and cp.start_date <= '" . $datefin . "') 
                        and 
                        (cp.end_date >= '" . $datedeb . "' and cp.end_date <= '" . $datefin . "')
                    )
                )
            GROUP BY cp.id
            ORDER BY cf.titre ASC";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getAvantPremiere()
    {
        $sql = "select cf.titre, cf.slug from 
                t_cine_film cf
                inner join t_cine_projection cp on cf.id = cp.id_cine_film
                 where cp.avant_premiere = 1
                 group by cf.slug
                 order by cp.id
                LIMIT 5";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getAllSalle()
    {
        $sql = "select id as value, nom as text from t_cine where status = 1 order by nom asc";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getAllLangue()
    {
        $sql = "select id as value, langue as text from t_cine_lang order by langue asc";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getAllTypeProj()
    {
        $sql = "select id as value, type as text from t_cine_type_projection order by type asc";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function searchFilmSelect($idxSearch)
    {
        $sql = "select id, titre from t_cine_film where lower(titre) like '%" . strtolower($idxSearch) . "%' order by titre";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function addUpdateProj(Request $request)
    {
        $data = $request->input('data');

        $data = (array) json_decode($data);

        $id = $data["id"];

        $allDateHeure = $data["allDateHeure"];
        $typeProj = $data["typeProj"];
       
        if (!$data["id"] || $data["id"] == 0){
            DB::table('t_cine_projection')->insert([
                "id_cine_film" => $data["film"],
                "id_cine" => $data["salle"],
                "id_cine_lang" => $data["langue"],
                "start_date" => $data["debSem"],
                "end_date" => $data["finSem"],
                "avant_premiere" => $data["av"]
            ]);
            $id = DB::getPdo()->lastInsertId();

        } else {
            DB::table('t_cine_projection')->where('id', $id)->update([
                "id_cine_film" => $data["film"],
                "id_cine" => $data["salle"],
                "id_cine_lang" => $data["langue"],
                "start_date" => $data["debSem"],
                "end_date" => $data["finSem"],
                "avant_premiere" => $data["av"]
            ]);
        }

        DB::table("t_cine_proj_types")->where('id_proj', $id)->delete();

        foreach ($typeProj as $key => $value) {
            DB::table('t_cine_proj_types')->insert([
                "id_proj" => $id,
                "id_type" => $value
            ]);
        }

        DB::table("t_cine_proj_heures")->where('id_cine_proj', $id)->delete();

        foreach ($allDateHeure as $key => $value) {
            DB::table('t_cine_proj_heures')->insert([
                "id_cine_proj" => $id,
                "jour" => $value->jour,
                "heure" => $value->heure,
                "lien_resa" => isset($value->lienResa) ? $value->lienResa : ""
            ]);
        }

        return $id;
    }

    public function getProjById($projId)
    {
        $sql = "SELECT cp.*, GROUP_CONCAT(cpt.id_type) as types, cf.titre as film FROM `t_cine_projection` cp
        left join t_cine_proj_types cpt on cp.id = cpt.id_proj
        left join t_cine_film cf on cp.id_cine_film = cf.id
        WHERE cp.id = " . $projId . "
        group by cp.id";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getProjHeuresById($projId)
    {
        $sql = "SELECT * from t_cine_proj_heures where id_cine_proj = " . $projId;

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    private function notExist($projId, $jour, $heure){
        $sql = "SELECT * FROM t_cine_proj_heures WHERE id_cine_proj = " . $projId . " and jour = " . $jour . " and heure = '" . $heure . "'";

        $results = DB::select( DB::raw($sql) );

        if (count($results) > 0) return false;
        else return true;
    }

    private function setHoursData($res){
        for ($i = 0; $i < 7; $i++){
            if ($i == 0) $jours = $res->sunday;
            if ($i == 1) $jours = $res->monday;
            if ($i == 2) $jours = $res->tuesday;
            if ($i == 3) $jours = $res->wednesday;
            if ($i == 4) $jours = $res->thursday;
            if ($i == 5) $jours = $res->friday;
            if ($i == 6) $jours = $res->saturday;

            if ($jours){
                if (strpos($jours, "-") && strpos($jours, "-") > 0)
                    $arrayJours = explode("-", $jours);
                else 
                    $arrayJours = explode(" ", $jours);
    
                foreach ($arrayJours as $key => $value) {
                    if ($value && trim($value) != ""){
                        $data_heures = array(
                            "id_cine_proj" => $res->id, 
                            "jour" => $i, 
                            "heure" => trim($value), 
                            "lien_resa" => ""
                        );
                        if ($this->notExist($res->id, $i, trim($value)))
                            $id_heure = DB::table('t_cine_proj_heures')->insertGetId($data_heures);
                    }
                }
    
                
            }
        }
        
    }


    public function updateCineHeures(){
        $query = "
            SELECT * from t_cine_projection order by id desc
        ";

        $_results = DB::select( DB::raw($query));
        foreach($_results as $r => $res){
            $this->setHoursData($res);  
        }

        return ["finished"];
    }

    private function inserGaumontWilsonFilm($data){
        $champ = [];
        $valeur = [];

        if ($data->title){
            array_push($champ, 'titre');
            array_push($valeur, $data->title);
        }

        if ($data->directors){
            array_push($champ, 'realisateur');
            array_push($valeur, $data->directors);
        }

        /*if ($data->title){
            array_push($champ, 'producteur');
            array_push($valeur, $data->title);
        }

        if ($data->title){
            array_push($champ, 'producteur_executif');
            array_push($valeur, $data->title);
        }

        if ($data->title){
            array_push($champ, 'scenariste');
            array_push($valeur, $data->title);
        }*/

        if ($data->actors){
            array_push($champ, 'acteurs');
            array_push($valeur, $data->actors);
        }

        if ($data->nationality){
            array_push($champ, 'nationalites');
            array_push($valeur, $data->nationality);
        }

        if (isset($data->genres)){
            array_push($champ, 'genres');
            array_push($valeur, $data->genres[0]);
        }

        if ($data->duration){
            $duree = (int) $data->duration;
            if ($duree > 0){
                $hours = floor($duree / 60);
                $minutes = ($duree % 60);
                $dureeFinal = sprintf('%02d:%02d', $hours, $minutes) . ":00";
                array_push($champ, 'duree');
                array_push($valeur, $dureeFinal);
            }
        }

        if (isset($data->releaseAt)){
            array_push($champ, 'annee_production');
            array_push($valeur, substr($data->releaseAt[0], 0, 4));
        }

        if ($data->synopsis){
            array_push($champ, 'synopsis');
            array_push($valeur, $data->synopsis);
        }

        if (isset($data->posterPath) && isset($data->posterPath->md)){
            array_push($champ, 'image');
            array_push($valeur, $data->posterPath->md);
        } else {
            if (isset($data->posterPath) && isset($data->posterPath->lg)){
                array_push($champ, 'image');
                array_push($valeur, $data->posterPath->lg);
            }
        }

        /*if ($data->title){
            array_push($champ, 'bo');
            array_push($valeur, $data->title);
        }

        if ($data->title){
            array_push($champ, 'interdiction');
            array_push($valeur, $data->title);
        }*/

        if ($data->distribution){
            array_push($champ, 'distributeur');
            array_push($valeur, $data->distribution);
        }

        /*if ($data->title){
            array_push($champ, 'date_sortie');
            array_push($valeur, $data->title);
        }*/

        if ($data->slug){
            array_push($champ, 'slug');
            array_push($valeur, $data->slug);
        }

        $sql = "INSERT INTO t_cine_film(" . implode(", ", $champ) .") values ('" . implode("', '", $valeur) . "')";
        /*DB::statement($sql);

        $id = DB::getPdo()->lastInsertId();*/
        return $sql;
    }

    public function autoUpdateCinema($dateSemDebStr){
        //$dateSemDeb = new DateTime($dt);
        $dateDeb = strtotime($dateSemDebStr);
        $dateSemFin = strtotime($dateSemDebStr);
        $dateSemFin = strtotime("+7 day", $dateSemFin);
        // gaumont wilson
        $retour = "";
        $allData = file_get_contents("https://www.cinemaspathegaumont.com/api/cinema/cinema-gaumont-wilson/shows?language=fr");
        $allFilms = json_decode($allData)->shows;
        $idx = 0;
        $allFilms = (array) $allFilms;

        $allReq = [];

        foreach ($allFilms as $slug => $val){
            $allDays = $val->days;
            $allDates = [];
            foreach($allDays as $dt => $dateval){
                $dtDate = strtotime($dt);
                if ($dateSemFin >= $dtDate && $dtDate <= $dateSemFin){
                    $allDates[$dt] = $dateval;
                }
            }

            if (count($allDates) > 0){
                $filmDetail =  $this->getFilmDetailBySlug($slug);
                if (count($filmDetail) <= 0){
                    $dataFilm = json_decode(file_get_contents("https://www.cinemaspathegaumont.com/api/show/" . $slug . "?language=fr"));
                    array_push($allReq, $this->inserGaumontWilsonFilm($dataFilm));
                }
            }
        }

        return json_encode( $allReq);
    }
    
    
    public function dupliquer(){
        $sql = "SELECT * FROM `t_cine_projection` WHERE `start_date` = '2021-12-22' and (id_cine <> 1 and id_cine <> 8 and id_cine <> 20) order by id asc";

        $results = DB::select( DB::raw($sql) );

        foreach ( $results as $result ){
            $sql2 = "INSERT INTO t_cine_projection(id_cine_film, id_cine, id_cine_lang, start_date, end_date) values (" . $result->id_cine_film . "," . $result->id_cine . "," . $result->id_cine_lang . ",'2021-12-29','2022-01-04')";
            DB::statement($sql2);

            $id = DB::getPdo()->lastInsertId();
            
            $sql3 = "INSERT INTO t_cine_proj_heures(id_cine_proj, jour, heure, lien_resa) (select " . $id . ", cph.jour, cph.heure, cph.lien_resa from t_cine_proj_heures cph  where cph.id_cine_proj = " . $result->id . ")";
            DB::statement($sql3);
            
        }
        return "fin";
    }
    
    public function dupliquer2(){
        $sql = "select cp.*, cpt.id_type
                from t_cine_projection cp 
                left join  t_cine_proj_types cpt on cp.id = cpt.id_proj
                where cp.start_date = '2021-12-22'";

        $results = DB::select( DB::raw($sql) );

        foreach ( $results as $result ){
            try{
                $sql2 = "INSERT INTO t_cine_proj_types(id_proj, id_type) values ( coalesce((select cp.id from t_cine_projection cp where cp.id_cine_film = " . $result->id_cine_film . " and cp.id_cine = " . $result->id_cine . " and cp.id_cine_lang = " . $result->id_cine_lang . " and cp.start_date = '2021-12-22' limit 1), 0), " . $result->id_type . ")";
                DB::statement($sql2);
            } catch (\Exception $e) {
                return $e->getMessage();
            }
        }
        return "fin";
    }
    
    public function dupliquer3(){
        //$sql = "SELECT * FROM `t_cine_projection` WHERE `start_date` = '2022-01-05' and (id_cine = 19 or id_cine = 21 or id_cine = 9 or id_cine = 22 or id_cine = 11 or id_cine = 13 or id_cine = 18 or id_cine = 12 or id_cine = 14 or id_cine = 31) order by id asc";
        $sql = "SELECT * FROM `t_cine_projection` WHERE `start_date` = '2022-02-09' order by id asc";

        $results = DB::select( DB::raw($sql) );

        foreach ( $results as $result ){
            $sql2 = "INSERT INTO t_cine_projection(id_cine_film, id_cine, id_cine_lang, start_date, end_date) values (" . $result->id_cine_film . "," . $result->id_cine . "," . $result->id_cine_lang . ",'2021-02-16','2022-02-22')";
            DB::statement($sql2);

            $id = DB::getPdo()->lastInsertId();
            
            $sql3 = "INSERT INTO t_cine_proj_heures(id_cine_proj, jour, heure, lien_resa) (select " . $id . ", cph.jour, cph.heure, cph.lien_resa from t_cine_proj_heures cph  where cph.id_cine_proj = " . $result->id . ")";
            DB::statement($sql3);
            
            
        }
        return "fin";
    }
    
    public function dupliquer4(){
        /*$sql = "select cp.*, cpt.id_type
                from t_cine_projection cp 
                left join  t_cine_proj_types cpt on cp.id = cpt.id_proj
                where cp.start_date = '2022-01-26'
                and (id_cine = 19 or id_cine = 21 or id_cine = 9 or id_cine = 22 or id_cine = 11 or id_cine = 13 or id_cine = 18 or id_cine = 12 or id_cine = 14 or id_cine = 31)";*/
                
        $sql = "select cp.*, cpt.id_type
                from t_cine_projection cp 
                left join  t_cine_proj_types cpt on cp.id = cpt.id_proj
                where cp.start_date = '2022-02-09'
                ";

        $results = DB::select( DB::raw($sql) );

        foreach ( $results as $result ){
            try{
                $sql2 = "INSERT INTO t_cine_proj_types(id_proj, id_type) values ( coalesce((select cp.id from t_cine_projection cp where cp.id_cine_film = " . $result->id_cine_film . " and cp.id_cine = " . $result->id_cine . " and cp.id_cine_lang = " . $result->id_cine_lang . " and cp.start_date = '2022-02-09' limit 1), 0), " . $result->id_type . ")";
                DB::statement($sql2);
            } catch (\Exception $e) {
                return $e->getMessage();
            }
        }
        return "fin";
    }
    
    
    private function getIdFilm($titre, $filmLink = ""){
        $ligfilm = DB::table('t_cine_film')->where('slug', $this->SharedController->formatToSlug($titre))->first();

        if ($ligfilm){
            return $ligfilm->id;
        } else {

            if ($filmLink == "") return 0;

            $client = new Client();
            $crawler = $client->request('GET', 'https://www.allocine.fr' . $filmLink);
            //$array = $crawler->filter('.entity-card')->each(function ($element) {
                $titre = $crawler->filter(".titlebar-page .titlebar-title")->getNode(0)->nodeValue;
                
                $bodyInfo = $crawler->filter(".entity-card .meta-body-info")->getNode(0)->nodeValue;
                $bodyInfos = explode("/", $bodyInfo);
                $genres = end($bodyInfos);
                
                $synopsis = "";
                
                $s1 = $crawler->filter(".ovw-synopsis .content-txt ");
                if (is_object($s1)){
                    $s2 = $s1->getNode(0);
                    if (is_object($s2)){
                        $synopsis = $s2->nodeValue;
                    }
                }
                
                
                $image = $crawler->filter(".entity-card .thumbnail-img")->attr("src");
                /*var_dump($titre);
                var_dump($realisateur);
                var_dump($producteur);
                var_dump($acteurs);
                var_dump($genres);
                var_dump($annee_production);
                var_dump($image);*/

                $dataFilm = [
                    "titre" => $titre,
                    "genres" => $genres,
                    "synopsis" => $synopsis,
                    "image" => $image,
                    "slug" => $this->SharedController->formatToSlug($titre)
                ];

                $objRealProd = $crawler->filter(".entity-card .meta-body-direction");
                if (is_object($objRealProd)){
                    if (is_object($objRealProd->getNode(0))){
                        $realisateur =  str_replace("De", "", $objRealProd->getNode(0)->nodeValue);
                        $dataFilm["realisateur"] = $realisateur;
                    }
                    if (is_object($objRealProd->getNode(1))){
                        $producteur =  str_replace("Par", "", $objRealProd->getNode(1)->nodeValue);
                        $dataFilm["producteur"] = $producteur;
                    }
                }
                
                $objAct = $crawler->filter(".entity-card .meta-body-actor")->getNode(0);
                if ($objAct && is_object($objAct)){
                    $acteurs =  str_replace("Avec", "", $objAct->nodeValue);
                    $dataFilm["acteurs"] = $acteurs;
                }

                $objAnnee = $crawler->filter(".entity-card .date.blue-link")->getNode(0);
                if ($objAnnee && is_object($objAnnee)) {
                    $annee_productions =  $objAnnee->nodeValue;
                    $annee_productions = explode(" ", $annee_productions);
                    $annee_production = end($annee_productions);
                    $dataFilm["annee_production"] = $annee_production;
                }

                DB::table('t_cine_film')->insert($dataFilm);
                $id = DB::getPdo()->lastInsertId();

                return $id;
            //});
        }
    }

    private function getIdLang($lang){
        $liglang = DB::table('t_cine_lang')->where('langue', $lang)->first();

        if ($liglang){
            return $liglang->id;
        } else return 1; // 1 = inconnue
    }

    private function checkOrInsertCineProj($id_cine_film, $id_cine, $id_cine_lang, $start_date, $end_date){

        $id = 0;
        
        $retour = (array)DB::table('t_cine_projection')->select('id')->where([
            ["id_cine_film", "=", $id_cine_film],
            ["id_cine", "=", $id_cine],
            ["id_cine_lang", "=", $id_cine_lang],
            ["start_date", "=", $start_date],
            ["end_date", "=", $end_date],
        ])->first();

        if (count($retour) > 0){
            $id = $retour['id'];
        } else {
            $data = [
                "id_cine_film" => $id_cine_film,
                "id_cine" => $id_cine,
                "id_cine_lang" => $id_cine_lang,
                "start_date" => $start_date,
                "end_date" => $end_date
            ];
            DB::table('t_cine_projection')->insert($data);
            $id = DB::getPdo()->lastInsertId();
        }

        return $id;
    }

    private function checkOrInsertCineProjTypes($idProj, $typeProj){

        $id = 0;
        
        $retour = (array)DB::table('t_cine_proj_types')->select('id')->where([
            ["id_proj", "=", $idProj],
            ["id_type", "=", $typeProj],
        ])->first();

        if (count($retour) > 0){
            $id = $retour['id'];
        } else {
            $data = [
                "id_proj" => $idProj,
                "id_type" => $typeProj,
            ];
            DB::table('t_cine_proj_types')->insert($data);
            $id = DB::getPdo()->lastInsertId();
        }

        return $id;
    }
    
    private function checkOrInsertJoursHeures($id_cine_proj, $jour, $heure, $lien_resa){

        $id = 0;
        
        $retour = (array)DB::table('t_cine_proj_heures')->select('id')->where([
            ["id_cine_proj", "=", $id_cine_proj],
            ["jour", "=", $jour],
            ["heure", "=", $heure]
        ])->first();

        if (count($retour) > 0){
            $id = $retour['id'];
        } else {
            $data2 = [
                "id_cine_proj" => $id_cine_proj,
                "jour" => $jour,
                "heure" => $heure
            ];

            if ($lien_resa){
                $data2["lien_resa"] = $lien_resa;
            }

            $dataDump2 = $data2;
            var_dump($dataDump2);
            echo "<br>";

            DB::table('t_cine_proj_heures')->insert($data2);
            $id = DB::getPdo()->lastInsertId();
        }

        return $id;
    }
    
    private function getSalleDetail($idSalle){
        $ligSalle = DB::table('t_cine')->where('id', $idSalle)->first();

        return $ligSalle;
    }

    public function autoUpdateCinemaAllocine($idSalle){
        
        $dateMercredi = date( 'Y-m-d', strtotime( 'wednesday this week' ) );
        $dateNextTuesday = date( 'Y-m-d', strtotime( 'next tuesday' ) );
        $typeProj = 4;
        
        $salleDetail = $this->getSalleDetail($idSalle);
        if ($salleDetail && count((array)$salleDetail)){
            $id_cine = $salleDetail->id;
            $salleUrlPrefix = $salleDetail->url;
        } else {
            echo "Salle inéxistante";
            die();
        }

        for ($jr = 3; $jr < 10; $jr++){
            //$client = new Client(HttpClient::create(['timeout' => 60]));
            $client = new Client();
            /*$client = new \Goutte\Client();

            $guzzleClient = new \GuzzleHttp\Client(array(
                'curl' => array(
                    CURLOPT_TIMEOUT => 60,
                ),
            ));
            
            $client->setClient($guzzleClient);*/

            $filmTitreInexistant = [];

            $allProjections = [];

            $lienPage = ($jr == 3) ? 'https://www.allocine.fr/seance/' . $salleUrlPrefix : 'https://www.allocine.fr/seance/d-' . ($jr-3) . '/' . $salleUrlPrefix;
            echo "<br>---------------------------------------------<br>";
            var_dump($lienPage);
            echo "<br>";
            //$crawler = $client->request('GET', $lienPage);
            $crawler = $client->request('GET', $lienPage); 

            //Gaumont Labège = 6
            $id_cine_film = 0;
            //$id_cine = 6;
            $id_cine_lang = 0;
            $start_date = $dateMercredi;
            $end_date = $dateNextTuesday;
            $typeProj = 4;

            $array = $crawler->filter('.entity-card')->each(function ($element) use ($id_cine, $start_date, $end_date, $typeProj, $jr) {
                $filmFitre = $element->filter('.meta-title-link')->getNode(0)->nodeValue;
                var_dump($filmFitre);
                echo "<br>";
                $filmLink = $element->filter('.meta-title-link')->attr('href');
                $id_cine_film = $this->getIdFilm($filmFitre, $filmLink);
                $element->filter('.showtimes-versions-holder .showtimes-version')->each(function ($element2) use ($filmFitre, $id_cine, $id_cine_film, $start_date, $end_date, $typeProj, $jr) {
                    $dateLang = $element2->text();
                    $dl = explode(" - ", $dateLang);
                    $dt =  trim($dl[0]);
                    $lg = strtoupper(trim(str_replace("En ","",$dl[1])));
                    $id_cine_lang = $this->getIdLang($lg);
                    // insertion t_cine_projection
                    // var_dump($filmFitre . ' > ' . $id_cine_film . ' > ' . $id_cine . ' > ' . $id_cine_lang . ' > ' . $start_date . ' > ' . $end_date);

                    $id = $this->checkOrInsertCineProj($id_cine_film, $id_cine, $id_cine_lang, $start_date, $end_date);

                    $this->checkOrInsertCineProjTypes($id, $typeProj);

                    $element2->filter('.showtimes-hour-block')->each(function ($element3) use ($id, $typeProj, $jr) {
                        $id_cine_proj = $id;
                        $jour = ($jr < 7) ? $jr : $jr - 7;

                        $lien_resa = "";
                        //if (is_object($element3->filter('.bookable'))) $lien_resa = $element3->filter('.bookable')->attr("href");
                        
                        if ($element3->filter('.showtimes-hour-item-value')->count() > 0 ){
                            $heure =  $element3->filter('.showtimes-hour-item-value')->getNode(0)->nodeValue;
                        } else if ($element3->filter('.showtimes-hour-item.past')->count() > 0 ){
                            $heure =  $element3->filter('.showtimes-hour-item.past')->getNode(0)->nodeValue;
                        } else if ($element3->filter('.showtimes-hour-item')->count() > 0 ){
                            $heure =  $element3->filter('.showtimes-hour-item')->getNode(0)->nodeValue;
                            $heure = trim(str_replace("Réserver", "", $heure));
                        }    
                        var_dump($heure);
                        echo "<br>";
                        $this->checkOrInsertJoursHeures($id_cine_proj, $jour, $heure, $lien_resa);

                    });

                    echo "<br>";
                    //var_dump($element2->text());
                });
            });
        }

        echo "<br> FINISHED ";
        
    }

    private function getProjId($id_cine_film, $id_cine, $id_cine_lang, $start_date, $end_date){

        $id = 0;

        $retour = (array)DB::table('t_cine_projection')->select('id')->where([
            ["id_cine_film", "=", $id_cine_film],
            ["id_cine", "=", $id_cine],
            ["id_cine_lang", "=", $id_cine_lang],
            ["start_date", "=", $start_date],
            ["end_date", "=", $end_date],
        ])->first();

        if (count($retour) > 0){
            $id = $retour['id'];
        } else {
            $id = 0;
        }

        return $id;
    }

    private function updateLien($id_cine_proj, $jour, $heure, $lien_resa){
        DB::table('t_cine_proj_heures')->where("id_cine_proj", $id_cine_proj)
        ->where("jour",$jour)
        ->where("heure",$heure)
        ->update([
            "lien_resa" => $lien_resa
        ]);
            
    }

    private function getAllSalleLiens(){
        
        /*$quer = (array)DB::table('t_cine')->select('id', 'url')->where([
            ["status", "=", 1]
        ]);*/
        
        $sql = "select id, url from t_cine where status = 1";
        
        $results = (array)DB::select( DB::raw($sql) );

        return $results;
    }


    public function autoUpdateCinemaAllocineLiens($idSalle = ""){
        
        $dateMercredi = date( 'Y-m-d', strtotime( 'wednesday this week' ) );
        $dateNextTuesday = date( 'Y-m-d', strtotime( 'next tuesday' ) );
        $typeProj = 4;

        $start_date = $dateMercredi;
        $end_date = $dateNextTuesday;

        $allSalle = [];
        
        if ($idSalle){
            $salleDetail = $this->getSalleDetail($idSalle);
            if ($salleDetail && count((array)$salleDetail)){
                //$id_cine = $salleDetail->id;
                //$salleUrlPrefix = $salleDetail->url;
                $allSalle = [ ["id" => $salleDetail->id, "url" => $salleDetail->url] ];
            } else {
                echo "Salle inéxistante";
                die();
            }
        } else {
            $allSalle = $this->getAllSalleLiens();
        }
        
        
        foreach ($allSalle as $k => $v){
            $v = (array) $v;

            $id_cine = $v['id'];
            $salleUrlPrefix = $v['url'];
            // $jr = 4 car lancement jeudi (a remettre pour le 8eme ligne plus bas)
            for ($jr = 3; $jr < 10; $jr++){

                $client = new Client();
                $filmTitreInexistant = [];

                $allProjections = [];

                //$lienPage = ($jr == 4) ? 'https://www.allocine.fr/seance/' . $salleUrlPrefix : 'https://www.allocine.fr/seance/d-' . ($jr-3) . '/' . $salleUrlPrefix;

                $allFilms = [];

                $inc = $jr - 3;

                for ($i = 0; $i < 4; $i++){
                    $theatreId = str_replace(".html", "", str_replace("salle_gen_csalle=", "", $salleUrlPrefix));
                    $patternJour = ($inc == 0) ? "" : "d-" . $inc . "/";
                    $patternPage = ($i == 0) ? "" : "p-" . $i . "/";
                    $lienDataJson = file_get_contents("https://www.allocine.fr/_/showtimes/theater-" . $theatreId . "/" . $patternJour . $patternPage);
                    $lienData = json_decode($lienDataJson);
                    if ($lienData->error == false){
                        $allFilms = array_merge($allFilms,$lienData->results);
                    }
                }

                //var_dump($allFilms);

                

                //$id_cine

                foreach($allFilms as $k => $f){
                    $titre = $f->movie->title;
                    $filmId = $this->getIdFilm($titre, "");

                    echo $titre;
                    echo "<br>";

                    foreach($f->showtimes->dubbed as $k1 => $v){
                        $langId = 1;
                        if ($v->tags && strpos("English", $v->tags[0]) !== false){
                            $langId = 4;
                        }
                        if ($v->tags && strpos("French", $v->tags[0]) !== false){
                            $langId = 2;
                        }

                        $id_cine_proj = $this->getProjId($filmId, $id_cine, $langId, $start_date, $end_date);

                        $heure = strtotime($v->startsAt);
                        $heure = date('H:i', $heure);

                        $jj = ($jr < 7) ? $jr : $jr - 7;

                        if ($v->data && $v->data->ticketing && count($v->data->ticketing) > 0 && $v->data->ticketing[0]->urls && count($v->data->ticketing[0]->urls) > 0){
                            $lien_resa = $v->data->ticketing[0]->urls[0];

                            var_dump($id_cine_proj . " - " . $jj . " - " . $heure . " - " . $lien_resa);
                            echo "<br>";

                            //update lien
                            $this->updateLien($id_cine_proj, $jj, $heure, $lien_resa);
                        }
                    }

                    foreach($f->showtimes->original as $k1 => $v){
                        $langId = 1;
                        if ($v->tags && strpos("English", $v->tags[0]) !== false){
                            $langId = 4;
                        }
                        if ($v->tags && strpos("French", $v->tags[0]) !== false){
                            $langId = 2;
                        }

                        $id_cine_proj = $this->getProjId($filmId, $id_cine, $langId, $start_date, $end_date);

                        $heure = strtotime($v->startsAt);
                        $heure = date('H:i', $heure);

                        $jj = ($jr < 7) ? $jr : $jr - 7;

                        if ($v->data && $v->data->ticketing && count($v->data->ticketing) > 0 && $v->data->ticketing[0]->urls && count($v->data->ticketing[0]->urls) > 0){
                            $lien_resa = $v->data->ticketing[0]->urls[0];

                            

                            var_dump($id_cine_proj . " - " . $jj . " - " . $heure . " - " . $lien_resa);
                            echo "<br>";

                            //update lien
                            $this->updateLien($id_cine_proj, $jj, $heure, $lien_resa);
                        }
                    }

                    foreach($f->showtimes->local as $k1 => $v){
                        $langId = 1;
                        if ($v->tags && strpos("English", $v->tags[0]) !== false){
                            $langId = 4;
                        }
                        if ($v->tags && strpos("French", $v->tags[0]) !== false){
                            $langId = 2;
                        }

                        $id_cine_proj = $this->getProjId($filmId, $id_cine, $langId, $start_date, $end_date);

                        $heure = strtotime($v->startsAt);
                        $heure = date('H:i', $heure);

                        $jj = ($jr < 7) ? $jr : $jr - 7;

                        if ($v->data && $v->data->ticketing && count($v->data->ticketing) > 0 && $v->data->ticketing[0]->urls && count($v->data->ticketing[0]->urls) > 0){
                            $lien_resa = $v->data->ticketing[0]->urls[0];

                            var_dump($id_cine_proj . " - " . $jj . " - " . $heure . " - " . $lien_resa);
                            
                            echo "<br>";
                            //update lien
                            $this->updateLien($id_cine_proj, $jj, $heure, $lien_resa);
                        }
                        
                    }

                    foreach($f->showtimes->multiple as $k1 => $v){
                        $langId = 1;
                        if ($v->tags && strpos("English", $v->tags[0]) !== false){
                            $langId = 4;
                        }
                        if ($v->tags && strpos("French", $v->tags[0]) !== false){
                            $langId = 2;
                        }

                        $id_cine_proj = $this->getProjId($filmId, $id_cine, $langId, $start_date, $end_date);

                        $heure = strtotime($v->startsAt);
                        $heure = date('H:i', $heure);

                        $jj = ($jr < 7) ? $jr : $jr - 7;

                        if ($v->data && $v->data->ticketing && count($v->data->ticketing) > 0 && $v->data->ticketing[0]->urls && count($v->data->ticketing[0]->urls) > 0){
                            $lien_resa = $v->data->ticketing[0]->urls[0];

                            var_dump($id_cine_proj . " - " . $jj . " - " . $heure . " - " . $lien_resa);
                            echo "<br>";

                            //update lien
                            $this->updateLien($id_cine_proj, $jj, $heure, $lien_resa);
                        }
                    }
                    echo "<br><br>-----------<br><br>";
                }

                echo "<br><br>********************************<br><br>";
            }
        }

        echo "<br> FINISHED ";
        
    }

    public function regenerateFilmSlug(){
        $query = "
            SELECT id, titre from t_cine_film order by id asc limit 12
        ";

        $_results = DB::select( DB::raw($query));
        foreach($_results as $r => $res){
            DB::table('t_cine_film')->where('id', $res->id)->update([
                "slug" => $this->SharedController->formatToSlug($res->titre)
            ]);
        }

        return ["finished"];
    }

}
