<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
//use Illuminate\Support\Facades\Request;
use DB;
use App\Http\Controllers\SharedController;

class NewsController extends Controller
{

    protected $SharedController;

    public function __construct(SharedController $SharedController)
    {
        $this->SharedController = $SharedController;
    }

    /**
     * Handle the incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function __invoke(Request $request)
    {
        //
    }

    public function wLogs($data)
    {
        $logPath = "logs.txt";
        $mode = (!file_exists($logPath)) ? 'w':'a';
        $logfile = fopen($logPath, $mode);
        fwrite($logfile, "\r\n". $data);
        fclose($logfile);
    }

    public function getNews($id,$limit = -1)
    {
        $where = ($id != 0) ? " and n.id = " . $id : "";

        if (isset($limit) && $limit >=0 ){
            $offset = $limit;
            $limit = 10;
            $sql = "select n.*, nc.color, nc.nom as categ_nom from t_news n left join t_news_cat nc on n.type = nc.id where n.is_enabled = 'T' " . $where . " order by id desc limit ".$limit." offset ".$offset;

        } else {
            $sql = "select n.*, nc.color, nc.nom as categ_nom from t_news n left join t_news_cat nc on n.type = nc.id where n.is_enabled = 'T' " . $where . " order by id desc";
        }
        
        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getNewsBySlug($slug,$limit)
    {
        $where = ($slug != "0") ? " and n.slug = '" . $slug . "'" : "";

        $isdetail = false;

        if ($limit >= 0){
            if ($limit == 0) {
                $limit = 2;
                $offset = 0;
                $isdetail = true;
            } else {
                $offset = $limit;
            }
            
            $sql = "select n.*, nc.color, nc.nom as categ_nom from t_news n left join t_news_cat nc on n.type = nc.id where n.is_enabled = 'T' " . $where . " order by id desc limit ".$limit." offset ".$offset;

        } else {
            $sql = "select n.*, nc.color, nc.nom as categ_nom from t_news n left join t_news_cat nc on n.type = nc.id where n.is_enabled = 'T' " . $where . " order by id desc";
        }

        $results = DB::select( DB::raw($sql) );

        if ($isdetail == true){
            $this->SharedController->setCounter(3, 0, $results[0]->id);
        }

        return $results;
    }

    public function getNewsbyCateg($cat, $nb)
    {
        $limit = "";
        if ($nb && $nb != 0)  $limit = " limit " . $nb;

        $sql = "select 
                    n.*, nc.nom as nc_nom, nc.description as nc_descr, nc.color as nc_color, nc.colonne as nc_col, nc.ordre as nc_ordre 
                from t_news n 
                    inner join t_news_cat nc on n.type = nc.id
                where n.type = '" . $cat . "' AND n.is_enabled = 'T'
                " . $limit;

        //$this->wLogs(json_encode($sql));

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getNewsAValider($id)
    {
        $where = ($id != 0) ? " and n.id = " . $id : "";

        $sql = "select n.*, nc.color, nc.nom as categ_nom, 0 as showVForm from t_news n left join t_news_cat nc on n.type = nc.id where n.is_enabled = 'F' " . $where . " order by n.id desc ";

        //$this->wLogs(json_encode($sql));

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function removeNews(Request $request)
    {
        $id = $request->input('selectedId');

        $results = DB::table('t_news')->where('id', '=', (int)$id)->update([
            'is_enabled' => 'D'
        ]);

        return $this->getNews(0);
    }

    public function getNewsCategories()
    {
        $sql = "select * from t_news_cat order by nom asc";

        //$this->wLogs(json_encode($sql));

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function addNews(Request $request)
    {
        $titre = $request->input('titre');
        $categorie = $request->input('categorie');
        $dateDeb = $request->input('dateDeb');
        $dateFin = $request->input('dateFin');
        $horaire = $request->input('horaire');
        $adresse = $request->input('adresse');
        $prix = $request->input('prix');
        $tel = $request->input('tel');
        $web = $request->input('web');
        $lien = $request->input('lien');
        $email = $request->input('email');
        $description = $request->input('description');
        $slug = $this->SharedController->formatToSlug($titre);

        $filename = $request->input('filename');
        $filecompl1 = $request->input('filecompl1');
        $filecompl2 = $request->input('filecompl2');
        $filecompl3 = $request->input('filecompl3');
        $youtube = $request->input('youtube');

        $dt = $dateDeb;
        /*if ($dateDeb) $dt = "Du" . $dateDeb;
        if ($dateFin) $dt = " au " . $dateFin;*/

        $data = [
                'titre' => $titre,
                'descr' => $description,
                'is_enabled' => ($request->input('fromFront') == 0 ? 'T' : 'F'),
                'tw' => ($request->input('fromFront') == 0 ? 'T' : 'F'),
                'slug' => $slug
                ];
        
        if ($dt) $data['date'] = $dt;
        if ($horaire) $data['hor'] = $horaire;
        if ($adresse) $data['lieu'] = $adresse;
        if ($prix) $data['prix'] = $prix;
        if ($tel) $data['telweb'] = $tel;
        if ($lien) $data['nom'] = $lien;
        if ($email) $data['mail'] = $email;
        if ($filename) $data['img_path'] = $filename;
        if ($filename) $data['img_grand'] = $filename;
        if ($web) $data['web'] = $web;
        if ($lien) $data['lienweb'] = $lien;
        if ($categorie) $data['type'] = $categorie;
        if ($filecompl1) $data['img_compl1'] = $filecompl1;
        if ($filecompl2) $data['img_compl2'] = $filecompl2;
        if ($filecompl3) $data['img_compl3'] = $filecompl3;
        if ($youtube) $data['youtube'] = $youtube;


        DB::table('t_news')->insert($data);
        $id = DB::getPdo()->lastInsertId();
        
        $this->SharedController->addSEO(4, $id, $titre, $slug);

        return $this->getNews(0);
    }


    public function updateNews(Request $request)
    {
        $id = $request->input('id');
        $titre = $request->input('titre');
        $categorie = $request->input('categorie');
        $dateDeb = $request->input('dateDeb');
        $dateFin = $request->input('dateFin');
        $horaire = $request->input('horaire');
        $adresse = $request->input('adresse');
        $prix = $request->input('prix');
        $tel = $request->input('tel');
        $web = $request->input('web');
        $lien = $request->input('lien');
        $email = $request->input('email');
        $description = $request->input('description');
        $filecompl1 = $request->input('filecompl1');
        $filecompl2 = $request->input('filecompl2');
        $filecompl3 = $request->input('filecompl3');
        $youtube = $request->input('youtube');

        $filename = $request->input('filename');

        $dt = $dateDeb;
        /*if ($dateDeb) $dt = "Du" . $dateDeb;
        if ($dateFin) $dt = " au " . $dateFin;*/

        /*$data = [
                'titre' => $titre,
                'descr' => $description,
                'is_enabled' => ($request->input('fromFront') == 0 ? 'T' : 'F'),
                'tw' => ($request->input('fromFront') == 0 ? 'T' : 'F'),
                ];*/

        if ($request->input('fromFront') === 0){
            $data['is_enabled'] = 'T';
            $data['tw'] = 'T';
        } else if ($request->input('fromFront') === 1){
            $data['is_enabled'] = 'F';
            $data['tw'] = 'F';
        }
        
        if ($titre) {
            $data['titre'] = $titre;
            $slug = $this->SharedController->formatToSlug($titre);
            $data['slug'] = $slug;
        }
        if ($description) $data['descr'] = $description;
        if ($dt) $data['date'] = $dt;
        if ($horaire) $data['hor'] = $horaire;
        if ($adresse) $data['lieu'] = $adresse;
        if ($prix) $data['prix'] = $prix;
        if ($tel) $data['telweb'] = $tel;
        if ($lien) $data['nom'] = $lien;
        if ($email) $data['mail'] = $email;
        if ($filename) $data['img_path'] = $filename;
        if ($filename) $data['img_grand'] = $filename;
        if ($web) $data['web'] = $web;
        if ($lien) $data['lienweb'] = $lien;
        if ($categorie) $data['type'] = $categorie;
        if ($filecompl1) $data['img_compl1'] = $filecompl1;
        if ($filecompl2) $data['img_compl2'] = $filecompl2;
        if ($filecompl3) $data['img_compl3'] = $filecompl3;
        $data['youtube'] = ($youtube) ? $youtube : "";


        $results = DB::table('t_news')->where('id', '=', (int)$id)->update($data);

        return $this->getNews(0);
    }


    public function validerNews(Request $request)
    {
        $id = $request->input('id');

        $results = DB::table('t_news')->where('id', '=', (int)$id)->update([
            'is_enabled' => 'T'
        ]);

        return $this->getNewsAValider(0);
    }


    public function addNewsComment(Request $request)
    {
        $idNews = $request->input('idNews');
        $nom = $request->input('nom');
        $mail = $request->input('mail');
        $commentaire = $request->input('commentaire');

        $data = [
                'id_news' => $idNews,
                'pseudo' => $nom,
                'email' => $mail,
                'commentaire' => $commentaire,
                ];


        DB::table('t_news_comment')->insert($data);
        $id = DB::getPdo()->lastInsertId();

        return $id;

    }

    public function getNewsComments($idNews, $isValider)
    {
        $where = " where is_deleted = 0";

        if ($idNews != 0){
            $where = " and n.id = " . $idNews;
        }

        if ($isValider != 0){
            if ($where == "")  $where = " where ";
            else $where = " and ";

            if ($isValider == 1) $where .= "nc.statut = 1";
            else if ($isValider == 2) $where .= "nc.statut = 0";
        }

        $sql = "select nc.id, nc.id_news, nc.pseudo, nc.email, nc.commentaire, nc.statut, n.titre, DATE_FORMAT(nc.date_add, '%d/%m/%Y %H:%i:%s') as date_add from t_news_comment nc inner join t_news n on nc.id_news = n.id " . $where;

        $this->wLogs(json_encode($sql));

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getNewsCommentsBySlug($slug, $isValider)
    {
        $where = " where nc.is_deleted = 0";

        if ($slug !== 0){
            $where .= " and n.slug = '" . $slug . "'";
        }

        if ($isValider != 0){
            if ($where == "")  $where .= " where ";
            else $where .= " and ";

            if ($isValider == 1) $where .= "nc.statut = 1";
            else if ($isValider == 2) $where .= "nc.statut = 0";
        }

        $sql = "select nc.id, nc.id_news, nc.pseudo, nc.email, nc.commentaire, nc.statut, n.titre, DATE_FORMAT(nc.date_add, '%d/%m/%Y %H:%i:%s') as date_add from t_news_comment nc inner join t_news n on nc.id_news = n.id " . $where;

        //$this->wLogs(json_encode($sql));

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function updateCommentStatus($id, $statut)
    {
        return DB::table('t_news_comment')
                    ->where('id', $id)
                    ->update(['statut' => $statut]);
    }


    public function deleteComment(Request $request)
    {
        $id = $request->input('id');

        $results = DB::table('t_news_comment')->where('id', '=', (int)$id)->update([
            'is_deleted' => 1
        ]);

        return $results;
    }


}
